'Include file for PowerBasic - supplied by Tony Kennard, tony@kyoceramita.co.uk
'
'-----BigSpeed zip dll API functions
'     Note: For arguments, True = 1 , False = 0.

'.....This function opens zip file and creates a list of items, corresponding to
'     contents of zip file. Must be called before any other function to get access
'     to zip file. ZipFileName is the path and full name of zip file,
'     for example: 'C:\TEST.ZIP'. Returns zero on success.
DECLARE FUNCTION zOpenZipFile LIB "bszip.dll" ALIAS "zOpenZipFile" (BYVAL ZipName AS STRING) AS LONG
'ZipName  is the full path AND NAME of the zip file.

'.....Closes zip file, opened with zOpenZipFile. Returns zero on success.
DECLARE FUNCTION zCloseZipFile LIB "bszip.dll" ALIAS "zCloseZipFile" () AS LONG

'.....Returns the total number of compressed files within zip file, i.e. the number
'     of items in the list. First item has index = 0, last item has '
'     Index = zGetTotalFiles - 1
DECLARE FUNCTION zGetTotalFiles LIB "bszip.dll" ALIAS "zGetTotalFiles" () AS LONG


'.....Returns the sum of uncompressed file size of all files within zip file.
DECLARE FUNCTION zGetTotalBytes LIB "bszip.dll" ALIAS "zGetTotalBytes" () AS LONG

'.....Returns the number of currently selected files.
DECLARE FUNCTION zGetSelectedFiles LIB "bszip.dll" ALIAS "zGetSelectedFiles" () AS LONG

'.....Returns the sum of uncompressed file size of selected files within zip file.
DECLARE FUNCTION zGetSelectedBytes LIB "bszip.dll" ALIAS "zGetSelectedBytes" () AS LONG

'.....If some error occurs in the DLL, this function will return a pointer to a string
'     that describes the error.
'     MUST be wrapped with StringFromPointer to obtain the VB String
DECLARE FUNCTION zGetLastErrorAsText LIB "bszip.dll" ALIAS "zGetLastErrorAsText" () AS LONG

'.....After extracting operation, this function will return the number of skipped
'     files - usually zero.
DECLARE FUNCTION zGetSkippedFiles LIB "bszip.dll" ALIAS "zGetSkippedFiles" () AS LONG

'.....This function returns the number of currently processed files and bytes.
'     This is necessary to calculate position of progress indicator.
'     Returns 1 on success.
DECLARE FUNCTION zGetRunTimeInfo LIB "bszip.dll" ALIAS "zGetRunTimeInfo" (BYREF ProcessedFiles AS LONG, BYREF ProcessedBytes AS LONG) AS BYTE

'.....To cancel extract operation, call this function.
DECLARE FUNCTION zCancelOperation LIB "bszip.dll" ALIAS "zCancelOperation" () AS BYTE

'.....Extracts only one of the file in zip file. This is useful for viewing/launching files.
DECLARE FUNCTION zExtractOne LIB "bszip.dll" ALIAS "zExtractOne" (BYVAL ItemNo AS LONG, _
  BYVAL ExtractDirectory AS STRING, BYVAL Password AS STRING, _
  BYVAL OverwriteExisting AS BYTE, BYVAL SkipOlder AS BYTE, _
  BYVAL UseFolders AS BYTE, BYVAL TestOnly AS BYTE, _
  BYVAL RTInfoFunc AS LONG) AS LONG
'     Parameters are:
'    ItemNo-  Item number of the file in the list.
'          0<= ItemNo <= zGetTotalFiles-1
'     ExtractDirectory- Directory where to extract files. If empty, current directory is used.
'     Password- password to be used, if file is encrypted.
'     OverwriteExisting- if 1, any existing file will be overwritten, otherwise will be skipped.
'     SkipOlder- if 1, files with newer date/time on the disk will not be overwritten.
'     UseFolders- if 1, the relative path information stored in zip file will be used to determine
'          location of the extracting file.
'     TestOnly- if 1, files are only tested, not saved to disk.
'     RTInfoFunc- pointer to the application function, which will be called
'          periodically from library to show runtime information,
'          for example some kind of progress bar. Within this function, application can
'          call zGetRunTimeInfo or zCancelOperation. If nil, no runtime information will
'          be available.
'          In VB5+, this may be called by using AddressOf in the call, in VB4 set to nil.
'
'     Return value is zero on success, otherwise application can call zGetLastErrorAsText to get
'     type of error.

'.....Extracts only files in the list, previously selected by zSelectFile.
'     Parameters are the same as in zExtractOne. Returns zero on success.
DECLARE FUNCTION zExtractSelected LIB "bszip.dll" ALIAS "zExtractSelected" ( _
   BYVAL ExtractDirectory AS STRING, BYVAL Password AS STRING, _
  BYVAL OverwriteExisting AS BYTE, BYVAL SkipOlder AS BYTE, BYVAL UseFolders AS BYTE, _
  BYVAL TestOnly AS BYTE, BYVAL RTInfoFunc AS LONG) AS LONG

'.....Extracts all files. Parameters are the same as in zExtractOne.
'     Returns zero on success.
DECLARE FUNCTION zExtractAll LIB "bszip.dll" ALIAS "zExtractAll" ( _
   BYVAL ExtractDirectory AS STRING, BYVAL Password AS STRING, _
   BYVAL OverwriteExisting AS BYTE, BYVAL SkipOlder AS BYTE, _
   BYVAL UseFolders AS BYTE, _
   BYVAL TestOnly AS BYTE, _
   BYVAL RTInfoFunc AS LONG) AS LONG


'.....Returns a pointer to the name of the file in the list with index i.
'     MUST be wrapped with StringFromPointer to obtain the VB String
DECLARE FUNCTION zGetFileName LIB "bszip.dll" ALIAS "zGetFileName" (BYVAL i AS LONG) AS LONG


'.....Returns a pointer to the extension of the file in the list with index i.
'     MUST be wrapped with StringFromPointer to obtain the VB String
DECLARE FUNCTION zGetFileExt LIB "bszip.dll" ALIAS "zGetFileExt" (BYVAL i AS LONG) AS LONG

'.....Returns a pointer to the stored path of the file in the list with index i.
'     MUST be wrapped with StringFromPointer to obtain the VB String
DECLARE FUNCTION zGetFilePath LIB "bszip.dll" ALIAS "zGetFilePath" (BYVAL i AS LONG) AS LONG

'.....Returns the MSDOS date of the file in the list with index i.
DECLARE FUNCTION zGetFileDate LIB "bszip.dll" ALIAS "zGetFileDate" (BYVAL i AS LONG) AS LONG

'.....Returns the MSDOS time of the file in the list with index i.
DECLARE FUNCTION zGetFileTime LIB "bszip.dll" ALIAS "zGetFileTime" (BYVAL i AS LONG) AS LONG

'.....Returns the uncompressed size of the file in the list with index i.
DECLARE FUNCTION zGetFileSize LIB "bszip.dll" ALIAS "zGetFileSize" (BYVAL i AS LONG) AS LONG

'.....Returns the compressed size of the file in the list with index i.
DECLARE FUNCTION zGetCompressedFileSize LIB "bszip.dll" ALIAS "zGetCompressedFileSize" (BYVAL i AS LONG) AS LONG

'.....Returns 1, if file in the list with index i is encrypted.
DECLARE FUNCTION zFileIsEncrypted LIB "bszip.dll" ALIAS "zFileIsEncrypted" (BYVAL i AS LONG) AS BYTE

'.....Returns a pointer to the result of the last operation on the file in the list with index i.
'     Usually 'Ok.'
'     MUST be wrapped with StringFromPointer to obtain the VB String
DECLARE FUNCTION zGetLastOperResult LIB "bszip.dll" ALIAS "zGetLastOperResult" (BYVAL i AS LONG) AS LONG

'.....Returns 1, if file in the list with index i is selected.
DECLARE FUNCTION zFileIsSelected LIB "bszip.dll" ALIAS "zFileIsSelected" (BYVAL i AS LONG) AS BYTE

'.....Select/Unselect file in the list with index i. If how is 1, the file will be selected,
'     otherwise will be unselected.
DECLARE FUNCTION zSelectFile LIB "bszip.dll" ALIAS "zSelectFile" (BYVAL i AS LONG, BYVAL how AS BYTE) AS BYTE

'.....To unselect all files in the list call this function
DECLARE FUNCTION zUnselectAll LIB "bszip.dll" ALIAS "zUnselectAll" () AS BYTE

'.....Selects files in the zip archive using wildcard pattern
DECLARE FUNCTION zSelectByWildcards LIB "bszip.dll" ALIAS "zSelectByWildcards" (BYVAL FileMask AS STRING, _
BYVAL IncludeSubfolders AS BYTE) AS LONG
'     Parameters are:
'     FileMask- Wildcard pattern to be used, for example: "C:\TEST\*.TXT; *.DOC"
'     IncludeSubfolders- If True, the subfolders will be searched too for matched files.


'.....Creates new empty zip file witn name ZipFileName, for example: "C:\temp\test.zip".
'     Returns zero on success.
DECLARE FUNCTION zCreateNewZip LIB "bszip.dll" ALIAS "zCreateNewZip" (BYVAL zipname AS STRING) AS LONG


'.....Call this function after zCreateNewZip or zOpenZipFile for every file, which must be included
'     in the Zip file. The function checks if the file already exists in the archive, date and time
'     of the file depending of the UpdateMode, and if the conditions are true, adds the file to the
'     list of "to be compressed files".
DECLARE FUNCTION zOrderFile LIB "bszip.dll" ALIAS "zOrderFile" (BYVAL FILENAME AS STRING, BYVAL StoredName AS STRING, _
   BYVAL UpdateMode AS LONG) AS LONG
'     Parameters are:
'     FileName- the full path and name of the file, for example: "C:\TEMP\TEST.TXT"
'     StoredName- this is the path and the name, under which the file must be stored in zip file,
'          for example: "TEMP\TEST.TXT".
'     UpdateMode- points if the file must be added if it is already exists in the archive. There
'          are 3 possible values:
'          0 - "Add (and Replace) file", if file does not exist in the archive, it will be added, if exists, it will be replaced.
'          1 - "Freshen file", file will be compressed only if it already exists in the archive and is newer.
'          2 - "Update file", file will be compressed if does not exists in the archive or if it exists, but is newer.
'     The return value is zero if the file is succesfuly added to "Add List".


'.....Selects files to be compressed into zip archive using wildcard pattern
DECLARE FUNCTION zOrderByWildcards LIB "bszip.dll" ALIAS "zOrderByWildcards" (BYVAL FileMask AS STRING, _
BYVAL BasePath AS STRING, _
BYVAL IncludeSubfolders AS BYTE, _
BYVAL CheckArchiveAttribute AS BYTE, _
BYVAL UpdateMode AS LONG) AS LONG
'     Parameters are:
'  FileMask - The wildcard pattern to be used, for example: "C:\TEST\*.TXT; *.DOC"
'  BasePath - This is the shared part of the path to be excluded from all selected files, when they will be stored in the archive, for example: "C:\TEST\".
'  IncludeSubfolders - If True, the subfolders will be searched too for matched files.
'  CheckArchiveAttribute - If True, only those of the files will be added, which have set "Archive" attribute.
'  UpdateMode - Points if the file must be added if it already exists in the archive. There are 3 possible values:
'   0 - "Add (and Replace) file", if the file does not exist in the archive, it will be added, if exists, it will be replaced.
'   1 - "Freshen file", the file will be compressed only if it already exists in the archive and is newer.
'   2 - "Update file", the file will be compressed if it does not exist in the archive or if it exists, but is newer.
'Return: Zero on success, otherwise an error code.


'.....Call this function to actually compress the files, previously requested with zOrderFile/zOrderByWildcards.
DECLARE FUNCTION zCompressFiles LIB "bszip.dll"  ALIAS "zCompressFiles"_
      (BYVAL TempDir AS STRING, _
       BYVAL Password AS STRING, _
       BYVAL CompressionMethod AS LONG, _
       BYVAL ResetArchiveAttribute AS BYTE, _
       BYVAL SpanSize AS LONG, _
       BYVAL Comment AS STRING, _
       BYVAL RTInfoFunc AS LONG) AS LONG
'     Parameters are:
'     TempDir- the temporary directory to be used
'     Password- if is not empty, the files will be encrypted with this password.
'     CompressionMethod- there are 4 possible values:
'          0 : Stored, no compression
'          1:     Fast compression
'          2:     Normal compression
'          3:     Max compression
'     ResetArchiveAttribute - if it is 1, the Archive attribute of the file will be reset after the
'          compressing of the file.
'

'     SpanSize - There are 3 cases here:
'          < 0 : Disabled - spanning is not allowed.
'          = 0 : Automatic - automatically prompt for another diskette when the current one is full. Applicable only for removable drives.
'          > 0 : Custom - multi-volume zip archive will be created and this value will be the maximum size of each volume. Applicable only for non-removable drives.

'     Comment - if is not empty, will be stored as a comment in the zip file.

'     RTInfoFunc- pointer to the application function, which will be called periodically from
'          library to show runtime information, for example some kind of progress bar.
'          Within this function, application can call zGetRunTimeInfo or zCancelOperation.
'          If nil, no runtime information will be available.
'          In VB5+, this may be called by using AddressOf in the call, in VB4 set to nil.
'
'     Return value is zero on success, otherwise application can call zGetLastErrorAsText
'     to get type of error.
'
'     Do not forget to close the zip file with zCloseZipFile.


'.....Removes the selected files from the zip archive. Returns zero on success, otherwise an error code.
DECLARE FUNCTION zDeleteFiles LIB "bszip.dll" ALIAS "zDeleteFiles" () AS LONG

'.....Returns the number of files requested for compression with functions zOrderFile/zOrderByWildcards.
DECLARE FUNCTION zGetOrderedFiles LIB "bszip.dll" ALIAS "zGetOrderedFiles" () AS LONG

'.....Returns the total size of files requested for compression with functions zOrderFile/zOrderByWildcards.
DECLARE FUNCTION zGetOrderedBytes LIB "bszip.dll" ALIAS "zGetOrderedBytes" () AS LONG

'.....Returns a pointer to the stored comment in the zip file
'     MUST be wrapped with StringFromPointer to obtain the VB String
DECLARE FUNCTION zGetComment LIB "bszip.dll" ALIAS "zGetComment" () AS LONG

'.....To check if the opened zip file is spanned on many disks/volumes, call this function.
DECLARE FUNCTION zIsSpanned LIB "bszip.dll" ALIAS "zIsSpanned" () AS BYTE

