//---------------------------------------------------------------------------
//This is the main unit of example how to use BigSpeed Zip DLL in Delphi
//Compiled with Delphi 5.0
//(c) BigSpeedSoft, 2001
//Be sure bszip.dll is available in the directory!!!
//---------------------------------------------------------------------------

unit main;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, ComCtrls,ShellApi,
  StdCtrls, checklst, FileCtrl, Grids;


const
  GColMax = 7;
  GridHdr : array [0..GColMax] of shortstring =
   ('  ','Name','Date','Time','Size','Ratio','Packed','Path');
  GColWdt : array [0..GColMax] of integer =
    (20,100,70,80,90,45,90,200);
  GRightCol : array [0..GColMax] of boolean =
    (false,false,false,false,true,true,true,false);

type
  TfMain = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    DrawGrid: TDrawGrid;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    sbOpen: TSpeedButton;
    sbAdd: TSpeedButton;
    sbRng: TSpeedButton;
    sbExtract: TSpeedButton;
    sbHelp: TSpeedButton;
    OpenZipDlg: TOpenDialog;
    sbClose: TSpeedButton;
    sbAddFiles: TSpeedButton;
    sbNew: TSpeedButton;
    dlgAddFiles: TOpenDialog;
    dlgSaveZip: TSaveDialog;
    sbDelete: TSpeedButton;
    function Compress : boolean;
    procedure ExecFile;
    procedure InvDrwGrd;
    procedure sbOpenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LoadGrid;
    procedure EmptyGrid;
    procedure FormDestroy(Sender: TObject);
    procedure DrawGridDrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure DrawGridDblClick(Sender: TObject);
    procedure DrawGridSelectCell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure DrawGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DrawGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure sbExtractClick(Sender: TObject);
    procedure sbHelpClick(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure sbAddFilesClick(Sender: TObject);
    procedure sbNewClick(Sender: TObject);
    procedure sbDeleteClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;



//API of BigSpeed Zip DLL


function zOpenZipFile(zipfilename:PChar): integer; stdcall;
function zCloseZipFile: integer; stdcall;
function zGetTotalFiles : integer; stdcall;
function zGetTotalBytes : integer; stdcall;
function zGetSelectedFiles : integer; stdcall;
function zGetSelectedBytes : integer; stdcall;
function zGetLastErrorAsText : pchar; stdcall;
function zGetSkippedFiles: integer; stdcall;
function zGetRunTimeInfo(var ProcessedFiles,ProcessedBytes : integer) : boolean; stdcall;
function zCancelOperation : boolean; stdcall;

function zExtractOne(ItemNo: integer;ExtractDirectory,Password: pchar; OverwriteExisting, SkipOlder, UseFolders, TestOnly : boolean; RTInfoFunc: pointer): integer; stdcall;
function zExtractSelected(ExtractDirectory,Password: pchar; OverwriteExisting, SkipOlder, UseFolders,TestOnly : boolean; RTInfoFunc: pointer): integer; stdcall;
function zExtractAll(ExtractDirectory,Password: pchar; OverwriteExisting, SkipOlder, UseFolders, TestOnly : boolean; RTInfoFunc: pointer): integer; stdcall;

function zGetFileName(i : integer) : pchar; stdcall;
function zGetFileExt(i : integer) : pchar; stdcall;
function zGetFilePath(i : integer) : pchar; stdcall;
function zGetFileDate(i : integer) : integer; stdcall;
function zGetFileTime(i : integer) : integer; stdcall;
function zGetFileSize(i : integer) : integer; stdcall;
function zGetCompressedFileSize(i : integer) : integer; stdcall;
function zFileIsEncrypted(i : integer) : boolean; stdcall;
function zGetLastOperResult(i : integer) : pchar; stdcall;

function zFileIsSelected(i : integer) : boolean; stdcall;
function zSelectFile(i: integer;how : boolean): boolean; stdcall;
function zUnselectAll : boolean; stdcall;
function zSelectByWildcards(FileMask: PChar; IncludeSubfolders: Boolean): Integer; stdcall;

function zCreateNewZip(ZipFileName: pchar) : integer; stdcall;
function zOrderFile(FileName, StoredName : pchar; UpdateMode : integer) : integer; stdcall;
function zOrderByWildcards(AFileMask, ABasePath: PChar; IncludeSubfolders, CheckArchiveAttribute: Boolean; UpdateMode: Integer): Integer; stdcall;
function zCompressFiles(TempDir, Password: pchar; CompressionMethod : integer; ResetArchiveAttribute : boolean; ASpanSize: Integer; AComment: PChar; RTInfoFunc: pointer) : integer; stdcall;

function zDeleteFiles: integer; stdcall;
function zGetOrderedFiles : integer; stdcall;
function zGetOrderedBytes : Integer; stdcall;
function zGetComment: PChar; stdcall;
function zIsSpanned: boolean; stdcall;




var
  fMain: TfMain;
  zipfilename, tempdir : string;
  begtime, endtime : cardinal;
  reqfiles, reqbytes, lsr : integer;
  onlymove : boolean;
  ImgList : TImageList;
  ImgInd, FFDel : TStringList;
  ProcRep: TStringList;

implementation

uses uExtrOpt, About, PgsInd, uCmprOpt, uReport;

{$R *.DFM}


function zOpenZipFile;external  'bszip.dll' name 'zOpenZipFile';
function zCloseZipFile;external  'bszip.dll' name 'zCloseZipFile';
function zGetTotalFiles;external  'bszip.dll' name 'zGetTotalFiles';
function zGetTotalBytes;external  'bszip.dll' name 'zGetTotalBytes';
function zGetSelectedFiles;external  'bszip.dll' name 'zGetSelectedFiles';
function zGetSelectedBytes;external  'bszip.dll' name 'zGetSelectedBytes';
function zGetLastErrorAsText;external  'bszip.dll' name 'zGetLastErrorAsText';
function zGetSkippedFiles;external  'bszip.dll' name 'zGetSkippedFiles';
function zGetRunTimeInfo;external  'bszip.dll' name 'zGetRunTimeInfo';
function zCancelOperation;external  'bszip.dll' name 'zCancelOperation';

function zExtractOne;external  'bszip.dll' name 'zExtractOne';
function zExtractSelected;external  'bszip.dll' name 'zExtractSelected';
function zExtractAll;external  'bszip.dll' name 'zExtractAll';

function zGetFileName;external  'bszip.dll' name 'zGetFileName';
function zGetFileExt;external  'bszip.dll' name 'zGetFileExt';
function zGetFilePath;external  'bszip.dll' name 'zGetFilePath';
function zGetFileDate;external  'bszip.dll' name 'zGetFileDate';
function zGetFileTime;external  'bszip.dll' name 'zGetFileTime';
function zGetFileSize;external  'bszip.dll' name 'zGetFileSize';
function zGetCompressedFileSize;external  'bszip.dll' name 'zGetCompressedFileSize';
function zFileIsEncrypted;external  'bszip.dll' name 'zFileIsEncrypted';
function zGetLastOperResult;external  'bszip.dll' name 'zGetLastOperResult';

function zFileIsSelected;external  'bszip.dll' name 'zFileIsSelected';
function zSelectFile;external  'bszip.dll' name 'zSelectFile';
function zUnselectAll;external  'bszip.dll' name 'zUnselectAll';
function zSelectByWildcards;external  'bszip.dll' name 'zSelectByWildcards';

function zCreateNewZip;external  'bszip.dll' name 'zCreateNewZip';
function zOrderFile;external  'bszip.dll' name 'zOrderFile';
function zOrderByWildcards;external  'bszip.dll' name 'zOrderByWildcards';
function zCompressFiles;external  'bszip.dll' name 'zCompressFiles';

function zDeleteFiles;external  'bszip.dll' name 'zDeleteFiles';
function zGetOrderedFiles;external  'bszip.dll' name 'zGetOrderedFiles';
function zGetOrderedBytes;external  'bszip.dll' name 'zGetOrderedBytes';
function zGetComment;external  'bszip.dll' name 'zGetComment';
function zIsSpanned;external  'bszip.dll' name 'zIsSpanned';




function RightStr(v: integer) : string;
var
  s1,s2 : string;
  i,j,k : integer;
begin
  s2 := '                              ';
  k := 30;
  s1 := IntToStr(v);
  i := length(s1);
  j := 3;
  while i > 0 do
  begin
    if j = 0 then begin
      s2[k] := ',';
      j := 3;
      dec(k);
    end;
    s2[k] := s1[i];
    dec(i); dec(j); dec(k);
  end;
  Result := copy(s2,k+1,30);
end;



procedure TfMain.LoadGrid;
var
  isReadOnly: Boolean;
begin
  with DrawGrid do
  begin
    RowCount := zGetTotalFiles + 1;
    FixedRows := 1;
    TopRow := 1;
    RowHeights[0] := 20;
  end;
  lsr := -1;
  StatusBar1.Panels[0].Text := 'Total: ' + RightStr(zGetTotalFiles)+ ' files  -  '
    +RightStr(zGetTotalBytes)+ ' bytes';
  StatusBar1.Panels[1].Text := 'Selected: 0 files';

  isReadOnly := (LowerCase(ExtractFileExt(ZipFileName)) <> '.zip') or zIsSpanned;
  sbExtract.Enabled := true;
  sbAdd.Enabled := true;
  sbRng.Enabled := true;
  sbClose.Enabled := true;
  sbAddFiles.Enabled := not isReadOnly;;
  sbDelete.Enabled := not isReadOnly;;
end;


procedure TfMain.EmptyGrid;
begin
  DrawGrid.FixedRows := 0;
  DrawGrid.RowCount := 1;
  DrawGrid.Refresh;
  StatusBar1.Panels[0].Text := 'Total: 0 files';
  StatusBar1.Panels[1].Text := 'Selected: 0 files';
  sbExtract.Enabled := false;
  sbAdd.Enabled := false;
  sbRng.Enabled := false;
  sbAddFiles.Enabled := false;
  sbDelete.Enabled := false;
  sbClose.Enabled := false;
end;



procedure TfMain.FormCreate(Sender: TObject);
var
  i: integer;
  SysIL: uint;
  SFI: TSHFileInfo;
  ps : string;
  pc : array [0..255] of char;
begin
  with DrawGrid do
  begin
    DefaultRowHeight := 16;
    RowHeights[0] := 20;
    ColCount := GColMax+1;
    for i := 0 to GColMax do
      ColWidths[i] := GColWdt[i];
  end;
  EmptyGrid;

  GetTempPath(sizeof(pc),pc);
  tempdir := StrPas(pc);
  onlymove := false;
  ProcRep := TStringList.Create;
  ImgInd := TStringList.Create;
  FFDel := TStringList.Create;
  FFDel.Duplicates := dupIgnore;
  FFDel.Sorted := false;
  FFDel.Add(tempdir+'$$report.txt');

  ImgList := TImageList.Create(self);
  SysIL := SHGetFileInfo('', 0, SFI, SizeOf(SFI), SHGFI_SYSICONINDEX or SHGFI_SMALLICON);
  if SysIL <> 0 then begin
    ImgList.Handle := SysIL;
    ImgList.ShareImages := TRUE;  // DON'T FREE THE SYSTEM IMAGE LIST!!!!!  BAD IDEA (tm)!
  end;

  ps := ParamStr(1);
  if length(ps) > 0 then
  begin
    if zOpenZipFile(PChar(ps)) <> 0 then
      MessageDlg('ERROR! '+zGetLastErrorAsText,mtError,[mbOk],0)
    else
    begin
      EmptyGrid;
      LoadGrid;
    end;
  end;
end;



procedure TfMain.FormDestroy(Sender: TObject);
var
  i : integer;
begin
  ImgList.Free;
  with FFDel do
  begin
    if count > 0 then
      for i := 0 to count - 1 do
        deletefile(strings[i]);
  end;
  FFDel.Free;
  ProcRep.Free;
  ImgInd.Free;
end;



procedure TfMain.sbOpenClick(Sender: TObject);
var
  zc: String;
begin
  OpenZipDlg.InitialDir := ExtractFileDir(OpenZipDlg.FileName);
  if not OpenZipDlg.Execute then
    exit;
  zipfilename := OpenZipDlg.FileName;
  if zOpenZipFile(PChar(zipfilename)) <> 0 then
    MessageDlg('ERROR! '+zGetLastErrorAsText,mtError,[mbOk],0)
  else
  begin
    EmptyGrid;
    LoadGrid;
    zc := zGetComment;
    if Length(zc) > 0 then
    begin
      fReport.Caption := 'Zip comment';
      fReport.RichEdit.Lines.Text := zc;
      fReport.ShowModal;
    end;
  end;
end;



function Date2Str(dd: word): string;
var
  w : word;
  s1,s2 : string;
begin
  s1 := '';
  w := (dd shr 5) and $f;
  if w < 10 then
    s1 := s1 + '0' + IntToStr(w) + '/'
  else
    s1 := s1 + IntToStr(w) + '/';

  w := dd and $1f;
  if w < 10 then
    s1 := s1 + '0' + IntToStr(w) + '/'
  else
    s1 := s1 + IntToStr(w) + '/';

  w := (dd shr 9) and $7f;
  s2 := IntToStr(1980+w);
  s1 := s1 + copy(s2,3,2);
  result := s1;
end;


function Time2Str(dd: word): string;
var
  w : word;
  s1 : string;
begin
  s1 := '';
  w := (dd shr 11) and $1f;
  if w < 10 then
    s1 := s1 + '0' + IntToStr(w) + ':'
  else
    s1 := s1 + IntToStr(w) + ':';

  w := (dd shr 5) and $3f;
  if w < 10 then
    s1 := s1 + '0' + IntToStr(w) + ':'
  else
    s1 := s1 + IntToStr(w) + ':';

  w := (dd and $1f) * 2;
  if w < 10 then
    s1 := s1 + '0' + IntToStr(w)
  else
    s1 := s1 + IntToStr(w);
  result := s1;
end;


procedure GetRowTxt(col,row : integer;var txt: string;
  var slc: boolean);
begin
  txt := '';
  slc := zFileIsSelected(row-1);
  case col of
      1 : begin
            txt := zGetFileName(row-1);
            if zFileIsEncrypted(row-1) then txt := txt + '+';
          end;
      2 : txt := Date2Str(zGetFileDate(row-1));
      3 : txt := Time2Str(zGetFileTime(row-1));
      4 : txt := RightStr(zGetFileSize(row-1));
      5 : if zGetFileSize(row-1) = 0 then txt := '0' else
            txt := IntToStr(round(zGetCompressedFileSize(row-1)*100/zGetFileSize(row-1)))+'%';
      6 : txt := RightStr(zGetCompressedFileSize(row-1));
      7 : txt := zGetFilePath(row-1);
  end;
end;


function GetIconIndex(row : integer): integer;
var
  SFI: TSHFileInfo;
  s : string;
begin
  if zGetFileName(row-1) = PChar('[FOLDER]') then
  begin
    s := ImgInd.Values['FOLDER'];
    if length(s) = 0 then
    begin
      SHGetFileInfo(zGetFileName(row-1), FILE_ATTRIBUTE_NORMAL or FILE_ATTRIBUTE_DIRECTORY, SFI,
        SizeOf(TSHFileInfo), SHGFI_SYSICONINDEX or SHGFI_USEFILEATTRIBUTES);
      ImgInd.Values['FOLDER'] := IntToStr(SFI.iIcon);
      Result := SFI.iIcon;
    end
    else
      Result := StrToInt(s);
  end
  else
  begin
    s := ImgInd.Values[zGetFileExt(row-1)];
    if length(s) = 0 then
    begin
      SHGetFileInfo(zGetFileName(row-1), FILE_ATTRIBUTE_NORMAL, SFI,
        SizeOf(TSHFileInfo), SHGFI_SYSICONINDEX or SHGFI_USEFILEATTRIBUTES);
      ImgInd.Values[zGetFileExt(row-1)] := IntToStr(SFI.iIcon);
      Result := SFI.iIcon;
    end
    else
      Result := StrToInt(s);
  end;
end;



procedure TfMain.DrawGridDrawCell(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
var
  x : integer;
  txt : string;
  slc : boolean;
begin
  with DrawGrid.Canvas do
  begin
    if row = 0 then
    begin
      Font := Self.Font;
      Brush := Self.Brush;
      Font.Style := [fsBold];
      Font.Color := clBlack;
      txt := GridHdr[Col];
      Pen.Color := clBlack;
      Pen.Style := psSolid;
      Rectangle(Rect.Left,Rect.Top,Rect.Right,Rect.Bottom);
      TextOut(Rect.Left+2,Rect.Top+1,txt);
    end
    else
    begin
      Font := Self.Font;
      Brush := Self.Brush;

      GetRowTxt(Col,Row,txt,slc);
      if slc then
      begin
        Brush.Color := clBlue;
        Font.Color := clHighLightText;
      end
      else
        Brush.Color := clWhite;
      FillRect(Rect);

      if col <> 0 then
      begin
        if GRightCol[Col] then
          x := Rect.Left + Rect.Right-Rect.Left-TextWidth(txt)-3
        else
          x := Rect.Left + 2;
        TextOut(x,Rect.Top,txt);
      end
      else
      begin
        x := GetIconIndex(row);
        ImgList.Draw(DrawGrid.Canvas,Rect.Left,Rect.Top,x);
      end;

      if DrawGrid.Selection.Top = row then
      begin
        Pen.Color := clBlue;
        MoveTo(Rect.Left,Rect.Top);
        LineTo(Rect.Right,Rect.Top);
        MoveTo(Rect.Left,Rect.Bottom-1);
        LineTo(Rect.Right,Rect.Bottom-1);
        if col = 0 then
        begin
          MoveTo(Rect.Left,Rect.Top);
          LineTo(Rect.Left,Rect.Bottom);
        end;
        if col = GColMax then
        begin
          MoveTo(Rect.Right-1,Rect.Top);
          LineTo(Rect.Right-1,Rect.Bottom);
        end;
      end;
    end;
  end;
end;



procedure TfMain.ExecFile;
var
  efn : string;
  r : integer;
begin
  if zGetTotalFiles < 1 then exit;
  efn := zGetFileName(DrawGrid.row-1);
  if efn = '[FOLDER]' then begin
    ShowMessage('There is nothing to do with folder');
    exit;
  end;
  r := zExtractOne(DrawGrid.row-1,PChar(tempdir),'',true, false, false,false,nil);
  if r <> 0 then
    MessageDlg('ERROR! '+zGetLastErrorAsText,mtError,[mbOk],0)
  else
  begin
    ShellExecute(0,nil,PChar(tempdir+efn),nil,nil,SW_SHOW);
    FFDel.Add(tempdir+efn);
  end;
end;


procedure TfMain.DrawGridDblClick(Sender: TObject);
begin
  ExecFile;
end;


procedure TfMain.InvDrwGrd;
var
  Rect: TRect;
begin
  with DrawGrid do
  begin
    Rect.TopLeft := CellRect(LeftCol,TopRow).TopLeft;
    Rect.BottomRight := ClientRect.BottomRight;
    InvalidateRect(Handle,@Rect,false);
  end;
end;




procedure TfMain.DrawGridSelectCell(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
var
  i, i1, i2 : integer;
  rngsel : boolean;

begin
  canselect := true;
  if row < 1 then exit;

  if onlymove then
  begin
    onlymove := false;
    InvDrwGrd;
    exit;
  end;

  if (not sbAdd.Down) and (not sbRng.Down) then
  begin
    if (zGetSelectedFiles = 1) and (lsr <> row-1) then
      zSelectFile(lsr,not zFileIsSelected(lsr))
    else
      if zGetSelectedFiles > 1 then
        for i := 0 to zGetTotalFiles-1 do
          zSelectFile(i,false);
  end;

  if sbRng.Down and (zGetSelectedFiles > 0) then
  begin
    rngsel := not zFileIsSelected(row-1);
    if lsr < row-1 then begin
      i1 := lsr; i2 := row-1; end
    else begin
      i1 := row-1; i2 := lsr; end;

    for i := i1 to i2 do
      zSelectFile(i,rngsel);
  end
  else
    zSelectFile(row-1,not zFileIsSelected(row-1));

  lsr := row-1;
  StatusBar1.Panels[1].Text := 'Selected: ' + RightStr(zGetSelectedFiles)+ ' files  -  '    +RightStr(zGetSelectedBytes)+ ' bytes';
  InvDrwGrd;
end;



procedure TfMain.DrawGridKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if DrawGrid.rowcount < 2 then exit;
  case key of
    17: sbAdd.Down := true;
    16: sbRng.Down := true;
    32:   with DrawGrid do
          begin
            if col > leftcol then
              col := col - 1
            else
              col := col + 1;
          end;
    40:   with DrawGrid do
            if row < rowcount-1 then begin
              onlymove := true;
              row := row + 1;
            end;
    38:   with DrawGrid do
            if row > 1 then begin
              onlymove := true;
              row := row - 1;
            end;
    37:   with DrawGrid do
          begin
            if LeftCol = 0 then
              LeftCol := ColCount - 1
            else
              LeftCol := LeftCol - 1;
            onlymove := true;
            Col := LeftCol;
          end;
    39:   with DrawGrid do
          begin
            if LeftCol = ColCount - VisibleColCount then
              LeftCol := 0
            else
              LeftCol := LeftCol + 1;
            onlymove := true;
            Col := LeftCol;
          end;
    36:   with DrawGrid do
          begin
            onlymove := true;
            row := 1;
          end;
    35:   with DrawGrid do
          begin
            onlymove := true;
            row := rowcount-1;
          end;
    33:   with DrawGrid do
          begin
            onlymove := true;
            if row - VisibleRowCount < 1 then
              row := 1
            else
              row := row - VisibleRowCount;
          end;
    34:   with DrawGrid do
          begin
            onlymove := true;
            if row + VisibleRowCount > RowCount - 1 then
              row := RowCount - 1
            else
              row := row + VisibleRowCount;
          end;
    13:   ExecFile;
  end;
  key := 0;
end;

procedure TfMain.DrawGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case key of
    17: sbAdd.Down := false;
    16: sbRng.Down := false;
  end;
  key := 0;
end;



procedure ShowRTInfo;
var
  ii, pf, pb : integer;
begin
  zGetRunTimeInfo(pf,pb);
  if reqbytes > 0 then
    ii := round(pb / reqbytes * 100)
  else
    ii := 0;

  with fPgsInd do
  begin
      stprocfiles.Caption := RightStr(pf);
      stprocbytes.Caption := RightStr(pb);
      PgsBar.Position := ii;
      Update;
    end;
  Application.ProcessMessages;
end;



procedure TfMain.sbExtractClick(Sender: TObject);
var
  testonly, wantrep : boolean;
  msg,extrdir : string;
  r, i, mr, pf, pb : integer;
begin
  with fExtrOpt do
  begin
    if zGetSelectedFiles = 0 then
    begin
      radAllFiles.Checked := true;
      radSelFiles.Enabled := false;
    end
    else
    begin
      radSelFiles.Enabled := true;
      radSelFiles.Checked := true;
    end;

    mr := ShowModal;
    if mr = mrCancel then
      Exit;

    if cmbDir.Items.Strings[0] <> cmbDir.Text then
      cmbDir.Items.Insert(0,cmbDir.Text);
    extrdir := cmbDir.Text;
  end;

  if mr = mrYes then
  begin
    testonly := true;
    fPgsInd.Caption := 'Testing ' + zipfilename;
  end
  else
  begin
    testonly := false;
    FPgsInd.Caption := 'Extracting from ' + zipfilename;
    if length(extrdir) > 0 then
    begin
      if extrdir[length(extrdir)] <> '\' then
        extrdir := extrdir + '\';

      if not DirectoryExists(extrdir) then
      begin
        MessageDlg('ERROR! Directory '+ extrdir + ' does not exist!',
        mtError,[mbOk],0);
        Exit;
      end;
    end;
  end;

  begtime := GetTickCount;
  Enabled := false;
  fPgsInd.PgsBar.Position := 0;
  if fExtrOpt.radAllFiles.Checked then
  begin
    reqbytes := zGetTotalBytes;
    fPgsInd.stselfiles.Caption := 'Selected files: ' + RightStr(zGetTotalFiles);
    fPgsInd.stselbytes.Caption := 'Selected bytes: ' + RightStr(reqbytes);
    fPgsInd.Show;
    r := zExtractAll(PChar(extrdir), PChar(fExtrOpt.edPswd.Text), fExtrOpt.cbOver.Checked, fExtrOpt.cbSkip.Checked, fExtrOpt.cbUse.Checked, testonly, addr(ShowRTInfo));
  end
  else
  begin
    if fExtrOpt.rbWildcards.Checked then
      zSelectByWildcards(PChar(fExtrOpt.edWildcards.Text), fExtrOpt.chkSubfolders.Checked);
    reqbytes := zGetSelectedBytes;
    fPgsInd.stselfiles.Caption := 'Selected files: ' + RightStr(zGetSelectedFiles);
    fPgsInd.stselbytes.Caption := 'Selected bytes: ' + RightStr(reqbytes);
    fPgsInd.Show;
    r := zExtractSelected(PChar(extrdir),PChar(fExtrOpt.edPswd.Text), fExtrOpt.cbOver.Checked, fExtrOpt.cbSkip.Checked, fExtrOpt.cbUse.Checked, testonly, addr(ShowRTInfo));
  end;
  endtime := GetTickCount - begtime;
  Enabled := True;
  fPgsInd.Hide;
  wantrep := false;
  if r <> 0 then
  begin
    if MessageDlg('ERROR! '+ zGetLastErrorAsText +
      #13' Would you like a report?',mtError,[mbYes,mbNo],0) = mrYes then
        wantrep := true;
  end
  else
  begin
    if zGetSkippedFiles = 0 then
      msg := 'All is Ok!  '
    else
      if zGetSkippedFiles = 1 then
        msg := 'There is a skipped file!   '
      else
        msg := 'There are ' + IntToStr(zGetSkippedFiles) + ' skipped files!  ';
    if MessageDlg(msg + '   Elapsed time ' + RightStr(endtime)+' ms'+
      #13' Would you like a report?',mtInformation,[mbYes,mbNo],0) = mrYes then
        wantrep := true;
  end;
  if wantrep then
  begin
    zGetRuntimeInfo(pf,pb);
    ProcRep.CLear;
    for i := 0 to pf-1 do
      ProcRep.Add(String(zGetLastOperResult(i)));

    ProcRep.Add('-----------------------------Total:');
    ProcRep.Add('Processed files: ' + RightStr(pf));
    ProcRep.Add('Processed bytes: ' + RightStr(pb));
    ProcRep.Add('Skipped files: ' + RightStr(zGetSkippedFiles));
    ProcRep.Add('Elapsed time: ' + RightStr(endtime)+' ms');

    ProcRep.SaveToFile(tempdir+'$$report.txt');
    fReport.RichEdit.Lines.LoadFromFile(tempdir+'$$report.txt');
    fReport.Caption := 'Report';
    fReport.ShowModal;
  end;
end;


procedure TfMain.sbHelpClick(Sender: TObject);
begin
  fAbout.ShowModal;
end;


procedure TfMain.sbCloseClick(Sender: TObject);
begin
  zCloseZipFile;
  EmptyGrid;
end;





function TfMain.Compress : boolean;
var
  rslt, um, i, pf, pb, spansize, rpl : integer;
  msg, fpn, fn, rp : string;
  wantrep : boolean;
begin
  Result := false;
  EmptyGrid;

  if fCmprOpt.ShowModal <> mrOk then
    Exit;

  spansize := -1;
  if fCmprOpt.rbAuto.Checked then
    spansize := 0
  else
    if fCmprOpt.rbCustom.Checked then
      spansize := StrToIntDef(fCmprOpt.cmbSize.Text, 0);
  um := fCmprOpt.rgUpdMode.ItemIndex;

  rp := Trim(LowerCase(fCmprOpt.edRoot.Text));
  if fCmprOpt.rbWilcards.Checked then
  begin
    //order by wildcards
    if Length(rp) = 0 then
    begin
      rp := Trim(ExtractFilePath(fCmprOpt.edMask.Text));
      if Length(rp) = 0 then
        rp := Trim(GetCurrentDir);
      if Length(rp) > 2 then
        if rp[2] = ':' then
          rp := Copy(rp, 1, 3);
    end;
    zOrderByWildcards(PChar(fCmprOpt.edMask.Text), PChar(rp), fCmprOpt.chkSubfolders.Checked, fCmprOpt.chkCAA.Checked, fCmprOpt.rgUpdMode.ItemIndex);
  end
  else
  begin
    dlgAddFiles.InitialDir := ExtractFileDir(dlgAddFiles.FileName);
    if not dlgAddFiles.Execute then
      Exit;

    if Length(rp) > 0 then
    begin
      if rp[Length(rp)] <> '\' then
        rp := rp + '\';
    end
    else
      rp := LowerCase(Copy(dlgAddFiles.Files[0], 1, 3));

    rpl := Length(rp);
    with dlgAddFiles.Files do
    begin
      for i := 0 to Count-1 do
      begin
        fpn := Strings[i];
        fn := fpn;
        if rpl > 0 then
          if LowerCase(Copy(fn, 1, rpl)) = rp then
            System.Delete(fn,1,rpl);
        zOrderFile(PChar(fpn), PChar(fn), um);
      end;
    end;
  end;

  if zGetOrderedFiles = 0 then
  begin
    ShowMessage('Nothing to do!');
    Result := False;
    Exit;
  end;


  reqbytes := zGetOrderedBytes;
  fPgsInd.Caption := 'Compressing to ' + zipfilename;
  fPgsInd.stselfiles.Caption := 'Selected files: ' + RightStr(zGetOrderedFiles);
  fPgsInd.stselbytes.Caption := 'Selected bytes: ' + RightStr(reqbytes);
  fPgsInd.Show;
  begtime := GetTickCount;
  rslt := zCompressFiles('', PChar(FCmprOpt.edPswd.Text),FCmprOpt.rgCmprMthd.ItemIndex, FCmprOpt.cbRAA.Checked, spansize, PChar(fCmprOpt.mmComment.Text), addr(ShowRTInfo));
  endtime := GetTickCount - begtime;
  fPgsInd.Hide;
  if rslt <> 0 then
  begin
    MessageDlg('ERROR! '+zGetLastErrorAsText,mtError,[mbOk],0);
    Exit;
  end;
  if zGetSkippedFiles = 0 then
    msg := 'All is Ok!  '
  else
    if zGetSkippedFiles = 1 then
      msg := 'There is a skipped file!   '
    else
      msg := 'There are ' + IntToStr(zGetSkippedFiles) + ' skipped files!  ';
    wantrep := false;
  if MessageDlg(msg + '   Elapsed time ' + RightStr(endtime)+' ms'+
    #13' Would you like a report?',mtInformation,[mbYes,mbNo],0) = mrYes then
      wantrep := true;
  if wantrep then
  begin
    zGetRuntimeInfo(pf,pb);
    ProcRep.CLear;
    for i := 0 to pf-1 do
      ProcRep.Add(String(zGetLastOperResult(i)));

    ProcRep.Add('-----------------------------Total:');
    ProcRep.Add('Processed files: ' + RightStr(pf));
    ProcRep.Add('Processed bytes: ' + RightStr(pb));
    ProcRep.Add('Skipped files: ' + RightStr(zGetSkippedFiles));
    ProcRep.Add('Elapsed time: ' + RightStr(endtime)+' ms');

    ProcRep.SaveToFile(tempdir+'$$report.txt');
    FReport.RichEdit.Lines.LoadFromFile(tempdir+'$$report.txt');
    fReport.Caption := 'Report';
    FReport.ShowModal;
  end;
  Result := true;
end;





procedure TfMain.sbAddFilesClick(Sender: TObject);
begin
  if Compress or (Length(ZipFileName) > 0) then
  begin
    zCloseZipFile;
    if zOpenZipFile(PChar(ZipFileName)) <> 0 then
    begin
      MessageDlg('ERROR! '+zGetLastErrorAsText,mtError,[mbOk],0);
      ZipFileName := '';
    end
    else
    begin
      EmptyGrid;
      LoadGrid;
    end;
  end;
end;




procedure TfMain.sbNewClick(Sender: TObject);
begin
  if not dlgSaveZip.Execute then
    exit;

  zipfilename := dlgSaveZip.FileName;
  if zCreateNewZip(PChar(zipfilename)) <> 0 then
  begin
    MessageDlg('ERROR! '+zGetLastErrorAsText,mtError,[mbOk],0);
    Exit;
  end;

  if Compress then
  begin
    zCloseZipFile;
    if zOpenZipFile(PChar(ZipFileName)) <> 0 then
    begin
      MessageDlg('ERROR! '+zGetLastErrorAsText,mtError,[mbOk],0);
      ZipFileName := '';
    end
    else
    begin
      EmptyGrid;
      LoadGrid;
    end;
  end;
end;






procedure TfMain.sbDeleteClick(Sender: TObject);
var
  r: integer;
begin
  if zGetSelectedFiles = 0 then
  begin
    MessageDlg('There is no selected file!', mtError,[mbOk],0);
    Exit;
  end
  else
  begin
    if MessageDlg(IntToStr(zGetSelectedFiles) + ' file(s) will be deleted! Are you sure?', mtWarning,[mbYes,mbNo],0) <> mrYes then
      Exit;

    Screen.Cursor := crHourGlass;
    r := zDeleteFiles;
    Screen.Cursor := crDefault;
    if r = 0 then
    begin
      zCloseZipFile;
      if zOpenZipFile(PChar(ZipFileName)) <> 0 then
      begin
        MessageDlg('ERROR! '+zGetLastErrorAsText,mtError,[mbOk],0);
        ZipFileName := '';
      end
      else
      begin
        EmptyGrid;
        LoadGrid;
      end;
    end
    else
    begin
      ZipFileName := '';
      MessageDlg(zGetLastErrorAsText,mtError,[mbOk],0);
    end;
  end;
end;


end.
