unit uCmprOpt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfCmprOpt = class(TForm)
    rgUpdMode: TRadioGroup;
    rgCmprMthd: TRadioGroup;
    edPswd: TEdit;
    Label1: TLabel;
    btnOk: TButton;
    btnCancel: TButton;
    cbRAA: TCheckBox;
    chkHide: TCheckBox;
    gbSpan: TGroupBox;
    lblSize: TLabel;
    rbAuto: TRadioButton;
    rbCustom: TRadioButton;
    cmbSize: TComboBox;
    rbNoSpan: TRadioButton;
    mmComment: TMemo;
    lblComment: TLabel;
    gbFiles: TGroupBox;
    edMask: TEdit;
    chkCAA: TCheckBox;
    chkSubfolders: TCheckBox;
    Label2: TLabel;
    edRoot: TEdit;
    rbDialog: TRadioButton;
    rbWilcards: TRadioButton;
    lblMask: TLabel;
    procedure chkHideClick(Sender: TObject);
    procedure rbNoSpanClick(Sender: TObject);
    procedure rbAutoClick(Sender: TObject);
    procedure rbCustomClick(Sender: TObject);
    procedure cmbSizeKeyPress(Sender: TObject; var Key: Char);
    procedure rbDialogClick(Sender: TObject);
    procedure rbWilcardsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fCmprOpt: TfCmprOpt;

implementation

{$R *.DFM}


//Hide the password
procedure TfCmprOpt.chkHideClick(Sender: TObject);
begin
  if chkHide.Checked then
    edPswd.PasswordChar := '*'
  else
    edPswd.PasswordChar := #0;
end;



procedure TfCmprOpt.rbNoSpanClick(Sender: TObject);
begin
  lblSize.Enabled := False;
  cmbSize.Enabled := False;
  cmbSize.Color := clMenu;
end;

procedure TfCmprOpt.rbAutoClick(Sender: TObject);
begin
  lblSize.Enabled := False;
  cmbSize.Enabled := False;
  cmbSize.Color := clMenu;
end;

procedure TfCmprOpt.rbCustomClick(Sender: TObject);
begin
  lblSize.Enabled := True;
  cmbSize.Enabled := True;
  cmbSize.Color := clWindow;
end;


procedure TfCmprOpt.cmbSizeKeyPress(Sender: TObject; var Key: Char);
begin
  if not ((Key in ['0'..'9']) or (Ord(Key) < 32)) then
    Key := #0;
end;


procedure TfCmprOpt.rbDialogClick(Sender: TObject);
begin
  lblMask.Enabled := False;
  edMask.Enabled := False;
  edMask.Color := clMenu;
  chkSubfolders.Enabled := False;
  chkCAA.Enabled := False;
end;

procedure TfCmprOpt.rbWilcardsClick(Sender: TObject);
begin
  lblMask.Enabled := True;
  edMask.Enabled := True;
  edMask.Color := clWindow;
  chkSubfolders.Enabled := True;
  chkCAA.Enabled := True;
end;

end.
